local core = LibStub("AceAddon-3.0"):GetAddon("tomQuest2")
local module = core:NewModule("tagQuestLog","AceEvent-3.0", "AceHook-3.0")
local LTQL = LibStub("AceLocale-3.0"):GetLocale("tomQuest2-TagQuestLog")
local tracker = core:GetModule("questsTracker")

local match = string.match

local DUNGEON = LFG_TYPE_DUNGEON
local HEROIC = DUNGEON_DIFFICULTY2
local shortTags = {
	[ELITE] = '+',
	[GROUP] = 'g',
	[PVP] = 'p',
	[RAID] = 'r',
	[DUNGEON] = 'd',
	[HEROIC] = 'd+',
	[DAILY] = "\226\128\162",
}

module.modName = LTQL["Quest Log Tag"]
function module:OnEnable()
	self:SecureHook("QuestLog_Update")
end


function module:QuestLog_Update()
	local offset, numEntries, numQuests = FauxScrollFrame_GetOffset(QuestLogListScrollFrame), GetNumQuestLogEntries()
	for i=1,QUESTS_DISPLAYED do
		local index = i + offset
		if index > numEntries then break end
		local title, level, tag, group, header, _, complete, daily = GetQuestLogTitle(index)
		local questLogTitle, questTitleTag, questNormalText, questCheck = _G["QuestLogTitle"..i], _G["QuestLogTitle"..i.."Tag"], _G["QuestLogTitle"..i.."NormalText"], _G["QuestLogTitle"..i.."Check"]
		questCheck:Hide()
		if not header then
			local uid = tonumber(match(GetQuestLink(index), 'quest:(%d+)'))
			tag = tag and tag or daily and DAILY or nil
			local shortTag = format("%s%s%s", tag and shortTags[tag] or "", (group and group > 0) and group or "", daily and (tag ~= DAILY and shortTags[DAILY] or "") or "")
			local taggedName = format("%s%s", (level or shortTag) and format("[%s%s]", level or "", shortTag or "") or "", title)
			questLogTitle:SetText("  "..taggedName)
			QuestLogDummyText:SetText("  "..taggedName)
			if (not complete) or (complete == 0) then questTitleTag:SetText("") end
			questNormalText:SetWidth(math.min(QuestLogDummyText:GetWidth(), 260 - questTitleTag:GetWidth()))
			if tracker:isQuestTracked(uid) then
				questCheck:SetPoint("LEFT", questLogTitle, "LEFT")
				questCheck:Show()
			end
		end
	end
end